/*
	$Id: heap.h,v 1.2 2001/09/09 16:10:51 syl Exp $

	Copyright (C) 1999, 2000, 2001 Syllabub
	Maroontress Fast Software.
*/

#define HEAP_ERROR -1
#define HEAP_SUCCESS 0

typedef struct HeapCell *HeapCell;

typedef struct HeapNode {
    struct HeapNode *next;   /* ꥹȡּ */
    struct HeapNode *prev;   /* ꥹȡ */
    struct HeapNode *parent; /* ĥ꡼ֿơ */
    struct HeapNode *left;   /* ĥ꡼ֺλҡ */
    struct HeapNode *right;  /* ĥ꡼ֱλҡ */
    HeapCell value;
} HeapNode;

typedef struct Heap {
    HeapNode *root;  /* 롼 */
    HeapNode *last;  /* ǸΥΡ (LN) */
    int n_nodes;     /* ҡפ˴ޤޤΡɤο */
    int (*compare)(HeapCell, HeapCell);
} Heap;

Heap * CreateHeap(int (*)(HeapCell, HeapCell));
int InsertIntoHeap(Heap *h, HeapCell c);
HeapCell TakeMinOfHeap(Heap *h);
#define NodesOfHeap(h) ((h)->n_nodes)
void ForEachOfHeap(Heap *h, void (*callback)(HeapCell));
void FreeHeap(Heap *h);

/*
  Heap * CreateHeap(compare):
  int compare(HeapCell, HeapCell);

  ؿCreateHeap()ϥҡפбHeap¤Τ֤
  compareˤϥҡפ˴ޤޤΡɤ羮Ӥؿꤹ롣

  Heap¤ΤǤʤȤNULL֤Heap¤Τפˤʤ
  ϴؿFreeHeap()ǲ롣
*/

/*
  int InsertIntoHeap(heap, cell):
  Heap *heap;
  HeapCell cell;

  ؿInsertIntoHeap()ϥҡפ˥ä롣heapоݤȤʤҡ
  бHeap¤ΤΥݥ󥿤ꤹ롣cellϲä륻Υݥ
  ꤹ롣μΤϥԡʤΤǡcellϾʤƤҡפ
  ФޤǤδͭǤʤФʤʤ

  ץꥱϥμΤǤHeapCell¤Τɬפ롣

  ؿInsertIntoHeap()HEAP_SUCCESS򡢼Ԥ
  HEAP_ERROR֤HEAP_ERRORϥɲüԤ̣Ƥ
  ΤǡξǤоݤΥҡפľξ֤Ѥ餺ͭʤޤޤǤ롣
*/

/*
  HeapCell TakeMinOfHeap(heap):
  Heap *heap;

  ؿTakeMinOfHeap()ϥҡפǾƬˤΥФ֤
  heapоݤȤʤҡפбHeap¤ΤΥݥ󥿤ꤹ롣
  
  ֤줿ϤǤ˥ҡפ˴ޤޤƤʤδؿǥҡפ
  ФϡΥμΤƤ褤

  ҡפξNULL֤롣
*/

/*
  void ForEachOfHeap(heap, callback):
  Heap *heap;
  void (*callback)(HeapCell);

  ؿForEachOfHeap()ϥҡפ˴ޤޤ륻Ȥơꤵ줿ؿ
  callbackƤӽФؿcallbackƤӽФϥҡפ˴ޤޤ륻
  ĿƱǤꡢҡפ˴ޤޤ뤹٤ƤΥ뤬٤İȤϤ
  롣Ȥʤ륻νʤ

  ؿForEachOfHeap()θƤӽФΥƥȤǴؿcallbackƤӽФ
*/

/*
  void FreeHeap(heap):
  Heap *heap;

  ؿFreeHeap()ϥҡפ롣heapоݤȤʤҡפб
  Heap¤ΤΥݥ󥿤ꤹ롣

  ҡפ˴ޤޤ륻ϲʤҡפ˴ޤޤ륻뤿
  ˤϡҡפˤʤޤǴؿTakeMinOfHeap()ǥФ줾
  Υ˴ؿFreeHeap()ƤӽФ
*/
